// Definicija klase iteratora za nizove (N_iter).

#ifndef _niter_h_
#define _niter_h_

#include "iter.h"
#include "niz3.h"

class N_iter: public Iter {
  Niz* niz;                                    // Pokaziva na niz.
  mutable int tek;                             // Indeks tekueg elementa.
public:
  N_iter(const Niz* n)                         // Stvaranje iteratora.
    { niz = const_cast<Niz*>(n); tek = 0; }
  bool ima() const                             // Ima li jo elemenata?
    { return tek >= 0 && tek < niz->duz; }
  N_iter& poc()                                // Pomeranje na poetak.
    { tek = 0; return *this; }
  const N_iter& poc() const
    { tek = 0; return *this; }
  N_iter& operator++() {                       // Pomeranje korak napred.
    if (!ima()) Zbirka::greska(Zbirka::G_TEK);
    tek++;
    return *this;
  }
  const N_iter& operator++() const
    { return ++const_cast<N_iter&>(*this); }
  Figura* operator->() {                       // Pokaziva na figuru.
    if (!ima()) Zbirka::greska(Zbirka::G_TEK);
    return niz->niz[tek];
  }
  const Figura* operator->() const
    { return const_cast<N_iter&>(*this).operator->(); }
  N_iter& operator+=(Figura* fig);             // Umetanje figure.
  N_iter& operator+=(const Figura& fig)
    { return *this += fig.kopija(); }
  N_iter& operator+=(Figura&& fig)
    { return *this += move(fig).kopija(); }
  N_iter& operator-=(Figura*& fig);            // Vaenje figure.
};

#endif
