// Definicija generike klase nizova (Niz4<>)

#ifndef _niz4_h_
#define _niz4_h_
#include <iostream>
using namespace std;

template <typename E>
  class Niz {
    E* niz;                              // Elementi niza.
    int kap, duz;                        // Kapacitet i duina.
  public:
    explicit Niz(int k = 10)             // Stvaranje praznog niza.
      { niz = new E [kap = k]; duz = 0; }
    Niz(const Niz& n);                   // Kopirajui konstruktor.
    ~Niz() { delete [] niz; }            // Unitavanje niza.
    Niz& operator=(const Niz& n) =delete;// Ne sme da se doeljuje.
    bool dodaj(const E& e) {             // Dodavanje podatka.
      if (duz == kap) return false;
      niz[duz++] = e; return true;
    }
    template <class U>                   // Izbacivanje elemenata niza koji
      Niz<E>& izbaci(U usl);             //   zadovoljavaju zadati uslov.
    template <typename T, class F>       // Stvaranje novog niza obraujui
      Niz<T> radi(F f) const;            //   elemente tekueg niza.
    template <typename T>                // Upisivanje niza u izlazni tok.
      friend ostream& operator<<(ostream& it, const Niz<T>& niz);
  };

// Definicije metoda i funkcija uz klasu Niz<> izvan klase.

template <typename E>                    // Kopirajui konstruktor.
  Niz<E>::Niz(const Niz& n) {
    niz = new E [kap = n.kap];
    duz = n.duz;
    for (int i=0; i<duz; i++) niz[i] = n.niz[i];
  }

template <typename E>                    // Izbacivanje elemenata niza koji
  template <class U>                     //   zadoljavaju zadati uslov.
    Niz<E>& Niz<E>::izbaci(U usl) {
      int j = 0;
      for (int i=0; i<duz; i++)
        if (!usl(niz[i])) niz[j++] = niz[i];
      duz = j;
      return *this;
    }

template <typename E>                    // Stvaranje novog niza obraujui
  template <typename T, class F>         //   elemente tekueg niza.
    Niz<T> Niz<E>::radi(F f) const {
      Niz<T> nizt(kap);
      for (int i=0; i<duz; i++) nizt.dodaj(f(niz[i]));
      return nizt;
  }

template <typename T>                    // Upisivanje niza u izlazni tok.
  ostream& operator<<(ostream& it, const Niz<T>& niz) {
    for (int i=0; i<niz.duz; i++) it << niz.niz[i] << ' ';
    return it;
  }

#endif
