// Definicije metoda uz klasu Red.

#include "red.h"

void Red::kopiraj(const Red& r) { // Kopiranje reda u objekat.
  prvi = posl = nullptr; duz = r.duz;
  for (Elem* tek=r.prvi; tek; tek=tek->sled)
    posl = (!prvi ? prvi : posl->sled) = new  Elem(tek->pod);
}

void Red::brisi() {               // Praznjenje objekta.
  while (prvi) { Elem* stari=prvi; prvi = prvi->sled; delete stari; }
  posl = nullptr; duz = 0;
}

Red& Red::operator+=(const Red& r) {      // Dodavanje reda objektu.
  if (r.prvi) {
    Red s(r);
    (!prvi ? prvi : posl->sled) = s.prvi;
    posl = s.posl; duz += s.duz;
    s.prvi = s.posl = nullptr; s.duz = 0;
  }
  return *this;
}

int Red::operator--() {           // Brisanje prvog elementa iz reda.
  if (duz == 0) return 0;
  int pod = prvi->pod;
  Elem* stari = prvi;
  if ((prvi = prvi->sled) == nullptr) posl = nullptr;
  delete stari;
  duz--;
  return pod;
}

Red Red::operator-(int k) const { // Red bez elemenata jednakih k.
  Red r;
  for (Elem* tek=prvi; tek; tek=tek->sled) if (tek->pod != k) r+=tek->pod;
  return r;
}

